<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html><head><title>
Xv Manual: Plot region
</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" title="Default" type="text/css" href="allegro.css"></head><body bgcolor=white text=black link="#0000ee" alink="#ff0000" vlink="#551a8b">
<h1><a name="Plot region">Plot region</a></h1>



<p><br>
the screen representation of plot is a plot region structure it is defined as follow:

<p><br>
<div class="al-api"><b>typedef struct plot_region <a name="pltreg">pltreg</a>;</b></div><br>
<blockquote class="code"><pre>
{
    dybox       db;         /* boundary of it */
    rec         def;            /* def of position */    
    struct box  *stack;            /* box translation of plot */
    struct box  *plt;            /* box of plot */
    int         x_off, y_off;        /* its bottom left corner */
    int         s_nx, s_ny;        /* the plot size on screen */
    int         screen_scale, max_scale, min_scale, auto_scale;    
        /* ratio from box to screen */
    float       mag_step;        /* magnification fac.*/
    int         x0, y0;            /* x &amp; y offset to box */
    dybox       *l_db;            /* list of active box */
    int         n_db, m_db;        /* number, alloced */
    <a href="xvin002.html#O_p" class="autotype" title="">O_p</a>         *one_p;            /* active = o_p[cur_op] */
    <a href="xvin002.html#O_p" class="autotype" title="">O_p</a>         **o_p;            /* the series of plot */
    int         n_op, m_op;        /* the number of plot */
    int         cur_op;            /* the current one */
    struct box  all;            /* the combination of plot */
    int         display_mode;    /* normal or all plots */
    int         *c_op;            /* an array for plot ordering */        
    char        *filename;        /* the name of the project file */    
    char        *path;            /* the name of the project directory */        
    int          mark_v,mark_h;    /* the positions of markers */
    struct hook  use;            /* allow to attach more data */    
</pre></blockquote>



<blockquote class="text"><pre>
# define     IS_ONE_PLOT        1024
# define    ALL_PLOTS    1025

# define    MAX_SCALE    8192
# define    MIN_SCALE    4096
# define    DEC_SCALE    2048
# define    INC_SCALE    1024
# define    AUTO_SCALE    512
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="xvin002.html#O_p" title="">O_p</a>,
<a class="xref" href="xvin002.html#free_one_plot" title="">free_one_plot</a>,
<a class="xref" href="xvin002.html#duplicate_plot_data" title="">duplicate_plot_data</a>.</blockquote>
<div class="al-api"><b>pltreg* <a name="build_plot_region">build_plot_region</a> (int x0, int y0, int w, int h);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>O_p* <a name="create_and_attach_one_plot">create_and_attach_one_plot</a> (pltreg *p,int x,int y,int type);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="add_data">add_data</a> (pltreg *pr, int type, void *stuff);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="add_data_to_pltreg">add_data_to_pltreg</a> (pltreg *pr, int type,void *stuff);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="remove_data">remove_data</a> (pltreg *pr, int type, void *stuff);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>#define <a name="remove_data_from_pltreg">remove_data_from_pltreg</a> remove_data</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="remove_data_from_pltreg">remove_data_from_pltreg</a> (pltreg *pr, int type, void *stuff);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="free_plot_region">free_plot_region</a> (pltreg* pr);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="do_one_plot">do_one_plot</a> (pltreg *pr);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="do_it_one_plot">do_it_one_plot</a> (pltreg *pr);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="display_plot_region">display_plot_region</a> (pltreg *pr);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="erase_box">erase_box</a> (void);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="draw_box">draw_box</a> (int dx, int dy, int scale, int color);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="spit_box_to_ps">spit_box_to_ps</a> (pltreg *pr, char *file);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="refresh_plot">refresh_plot</a> (pltreg *pr, int n_plot);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="update_just_plot">update_just_plot</a> (pltreg *pr);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="update_plot_db">update_plot_db</a> (pltreg *pr);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="run_pr_db">run_pr_db</a> (char ch);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>dybox* <a name="next_pr_db">next_pr_db</a> (pltreg *pr);</b></div><br>


<p><br>
/* pltreg             *find_plot_reg(acreg *ac); */

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>d_s* <a name="find_cur_data_set">find_cur_data_set</a> (pltreg *plt);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="shift_horz">shift_horz</a> (char ch);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="shift_vert">shift_vert</a> (char ch);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="drag_label">drag_label</a> (char ch);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="change_label">change_label</a> (char ch);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="show_peak">show_peak</a> (char ch);</b></div><br>




<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="x_pltdata_2_pr">x_pltdata_2_pr</a> (pltreg *pr, float x);</b></div><br>
    Convert from the current plot coordinate to the screen coordinate in X.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.




<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>,
<a class="xref" href="#y_pltdata_2_pr" title="">y_pltdata_2_pr</a>.</blockquote>
<div class="al-api"><b>int <a name="y_pltdata_2_pr">y_pltdata_2_pr</a> (pltreg *pr, float y);</b></div><br>
    Convert from the current plot coordinate to the screen coordinate in Y.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>,
<a class="xref" href="#x_pltdata_2_pr" title="">x_pltdata_2_pr</a>.</blockquote>
<div class="al-api"><b>float <a name="x_pr_2_pltdata">x_pr_2_pltdata</a> (pltreg *pr, int xvp);</b></div><br>
    Convert from the screen coordinate in X to the current plot coordinate.
    The data are assume to be in physical mode (with unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin. 


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>,
<a class="xref" href="#x_pr_2_pltdata_raw" title="">x_pr_2_pltdata_raw</a>.</blockquote>
<div class="al-api"><b>float <a name="y_pr_2_pltdata">y_pr_2_pltdata</a> (pltreg *pr, int yvp);</b></div><br>
    Convert from the screen coordinate in Y to the current plot coordinate.
    The data are assume to be in physical mode (with unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin.     


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>,
<a class="xref" href="#y_pr_2_pltdata_raw" title="">y_pr_2_pltdata_raw</a>.</blockquote>
<div class="al-api"><b>float <a name="x_pr_2_pltdata_raw">x_pr_2_pltdata_raw</a> (pltreg *pr, int xvp);</b></div><br>
    Convert from the screen coordinate in X to the current plot coordinate.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin.     


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>,
<a class="xref" href="#x_pr_2_pltdata" title="">x_pr_2_pltdata</a>.</blockquote>
<div class="al-api"><b>float <a name="y_pr_2_pltdata_raw">y_pr_2_pltdata_raw</a> (pltreg *pr, int yvp);</b></div><br>
    Convert from the screen coordinate in Y to the current plot coordinate.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin. 


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>,
<a class="xref" href="#y_pr_2_pltdata" title="">y_pr_2_pltdata</a>.</blockquote>
<div class="al-api"><b>dybox* <a name="make_box_active">make_box_active</a> (pltreg *pr, int type, int (*action)(char), int mode);</b></div><br>



<p><br>
/* local functions */

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="find_box_scale">find_box_scale</a> (struct box *bo, dybox *db);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>float <a name="interp">interp</a> (float p,float fp,float f0,float f1,float f2);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="set_plt_x_unit_set">set_plt_x_unit_set</a> (pltreg *pr, int n);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="set_plt_y_unit_set">set_plt_y_unit_set</a> (pltreg *pr, int n);</b></div><br>




<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="prepare_all_plots">prepare_all_plots</a> (pltreg *pr, int n_col);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="plots_in_three_columns">plots_in_three_columns</a> (struct box *bo);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="plots_in_two_columns">plots_in_two_columns</a> (struct box *bo);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="plots_in_one_column">plots_in_one_column</a> (struct box *bo);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="fft_fil_inr_outr">fft_fil_inr_outr</a> (float *x, int nx, int w_flag, int f, int w);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="fft_fil_inr_outc">fft_fil_inr_outc</a> (float *x, int nx, int w_flag, int f, int w);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="fft_fil_inc_outc">fft_fil_inc_outc</a> (float *x, int nx, int w_flag, int f, int w);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="least_square_fit_on_ds">least_square_fit_on_ds</a> (char ch);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="remove_plot">remove_plot</a>(char ch);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="load_plt_file_in_pltreg">load_plt_file_in_pltreg</a> (pltreg *pr, char *file, char *path);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>pltreg* <a name="find_pr_in_current_dialog">find_pr_in_current_dialog</a> (DIALOG *di);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="set_plt_x_unit_set">set_plt_x_unit_set</a> (pltreg *pr, int n);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="set_plt_y_unit_set">set_plt_y_unit_set</a> (pltreg *pr, int n);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>d_s* <a name="find_source_specific_ds_in_pr">find_source_specific_ds_in_pr</a> (pltreg *pr, char *source);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="find_op_nb_of_source_specific_ds_in_pr">find_op_nb_of_source_specific_ds_in_pr</a> (pltreg *pr, char *source);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>int <a name="find_op_nb_of_treatement_specific_ds_in_pr">find_op_nb_of_treatement_specific_ds_in_pr</a> (pltreg *pr, char *treatement);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>pltreg* <a name="load_cgr_file_in_pltreg">load_cgr_file_in_pltreg</a> (pltreg *pr, char *file_path, char *file);</b></div><br>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<div class="al-api"><b>pltreg* <a name="load_cgrfile_in_pltreg">load_cgrfile_in_pltreg</a> (pltreg *pr, char *fullfile);</b></div><br>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#pltreg" title="">pltreg</a>.</blockquote>
<hr><div class="al-back-to-contents"><a href="xvin.html">Back to contents</a></div>

</body>
</html>
